const jwt = require('jsonwebtoken');

const authenticateToken = (req, res, next) => {
  // Obține tokenul din antetul Authorization
  const token = req.header('Authorization')?.replace('Bearer ', ''); // Remove "Bearer " din antet

  if (!token) {
    return res.status(401).json({ message: 'Access denied. No token provided.' });
  }

  try {
    // Verifică și decodează tokenul
    const decoded = jwt.verify(token, process.env.JWT_SECRET);

    // Adaugă informațiile utilizatorului la obiectul `req`
    req.user = decoded;
    next(); // Permite continuarea cererii
  } catch (err) {
    console.error('Invalid token', err);
    return res.status(400).json({ message: 'Invalid token.' });
  }
};

module.exports = authenticateToken;
